"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CodeMirrorBookmark = /** @class */ (function () {
    function CodeMirrorBookmark(editor, position, domElement, insertLeft) {
        this.editor = editor;
        this.position = position;
        this.domElement = domElement;
        this.insertLeft = insertLeft;
        this.hidden = false;
        if (this.editor.getDisplayDecorations()) {
            this.show();
        }
        else {
            this.hidden = true;
        }
    }
    CodeMirrorBookmark.prototype.getPosition = function () {
        return this.position;
    };
    CodeMirrorBookmark.prototype.getDomElement = function () {
        return this.domElement;
    };
    CodeMirrorBookmark.prototype.isHidden = function () {
        return this.hidden;
    };
    CodeMirrorBookmark.prototype.show = function () {
        if (!this.mark) {
            this.createBookmarkWithDom();
            this.hidden = false;
        }
    };
    CodeMirrorBookmark.prototype.hide = function () {
        if (!this.hidden) {
            this.mark.clear();
            this.hidden = true;
            this.mark = null;
        }
    };
    CodeMirrorBookmark.prototype.remove = function () {
        if (this.mark) {
            this.hide();
        }
    };
    CodeMirrorBookmark.prototype.createBookmarkWithDom = function (insertLeft) {
        var opts = { widget: this.domElement, insertLeft: this.insertLeft };
        var start = { ch: this.position.column, line: this.position.line };
        this.mark = this.editor.editorImplementation.getDoc().setBookmark(start, opts);
    };
    return CodeMirrorBookmark;
}());
exports.CodeMirrorBookmark = CodeMirrorBookmark;
//# sourceMappingURL=codemirror-bookmark.js.map